#Evaluate GMMs for different thresholds and finds the Equal Error Rate

import os, numpy, math, pickle
from numpy import zeros,sign,mat
from sklearn import mixture

languages = ['arabic', 'english', 'farsi', 'french', 'german', 'hindi', 'japanese', 'korean', 'mandarin', 'spanish', 'tamil', 'vietnamese']
short = ['ar', 'en', 'fa', 'fr', 'ge', 'hi', 'ja', 'ko', 'ma', 'sp', 'ta', 'vi']

#languages = ['vietnamese']
#short = ['vi']
N= len(languages)

classes = ['Model', 'Anti']

S = '200'
#attrib = 'manner'
#attrib = 'place'
attrib = 'combine'

#testModel = 'Devtest'
#testDir = 'devtest'


testModel = 'Evltest'
testDir = 'evltest'

testModel = 'NIST'
testDir = 'NIST'

def my_range(start, end, step):
    while start<=end:
        yield start
        start += step

for k in range(N):
  for r in range(2):
    filehandler = open('gmms/'+attrib+'/'+short[k]+classes[r],'r')
    vars()[short[k]+classes[r]] = pickle.load(filehandler)

minDiff = numpy.ones(N)
bestR = numpy.zeros(N)

#Threshold values
Rarray = my_range(-5,0,0.01)
print Rarray

for R in Rarray:
  print R
  
  tests = numpy.zeros(N)
  approved = numpy.zeros(N)
  accuracy1 = numpy.zeros(N)
  
  for k in range(N):
    data = []
    f = open('../distances/'+S+'/'+attrib+'/'+testDir+'/'+short[k]+'Model.txt','r')
    for line in f:
      sample = numpy.zeros(12)
      splitLine = line.split(' ')
      for i in range(12):
        sample[i] = float(splitLine[i])
      data.append(sample)
  
    matrix = mat(data)
    L = len(data)
    tests[k] = L
    yM = eval(short[k]+'Model.eval(data)')
    yA = eval(short[k]+'Anti.eval(data)')
    
    for i in range(L):
      if (yM[0][i] - yA[0][i]) > R:
        approved[k] += 1
      
  for i in range(N):
    accuracy1[i] = float(approved[i])/tests[i]
     


  tests = numpy.zeros(N)
  approved = numpy.zeros(N)
  accuracy2 = numpy.zeros(N)
  for k in range(N):
    data = []
    f = open('../distances/'+S+'/'+attrib+'/'+testDir+'/'+short[k]+'Anti.txt','r')
    for line in f:
      sample = numpy.zeros(12)
      splitLine = line.split(' ')
      for i in range(12):
        sample[i] = float(splitLine[i])
      data.append(sample)
    
    matrix = mat(data)
    L = len(data)
    tests[k] = L
    yM = eval(short[k]+'Model.eval(data)')
    yA = eval(short[k]+'Anti.eval(data)')
    
    for i in range(L):
      if (yM[0][i] - yA[0][i]) < R:
        approved[k] += 1
        
  for i in range(N):
    accuracy2[i] = float(approved[i])/tests[i]
    
  
  #Find optimal R for each language
  for i in range(N):
    diff = math.fabs(accuracy1[i]-accuracy2[i])
    if diff < minDiff[i]:
      minDiff[i] = diff
      bestR[i] = R
      
#Run test once again using the optimal R-values
print '\n'+str(bestR)+'\n'

tests = numpy.zeros(N)
approved = numpy.zeros(N)
accuracy1 = numpy.zeros(N)
  
for k in range(N):
  data = []
  f = open('../distances/'+S+'/'+attrib+'/'+testDir+'/'+short[k]+'Model.txt','r')
  for line in f:
    sample = numpy.zeros(12)
    splitLine = line.split(' ')
    for i in range(12):
      sample[i] = float(splitLine[i])
    data.append(sample)
  
  matrix = mat(data)
  L = len(data)
  tests[k] = L
  yM = eval(short[k]+'Model.eval(data)')
  yA = eval(short[k]+'Anti.eval(data)')
    
  for i in range(L):
    if (yM[0][i] - yA[0][i]) > bestR[k]:
      approved[k] += 1
    
for i in range(N):
  accuracy1[i] = float(approved[i])/tests[i]
     
print accuracy1

tests = numpy.zeros(N)
approved = numpy.zeros(N)
accuracy2 = numpy.zeros(N)
for k in range(N):
  data = []
  f = open('../distances/'+S+'/'+attrib+'/'+testDir+'/'+short[k]+'Anti.txt','r')
  for line in f:
    sample = numpy.zeros(12)
    splitLine = line.split(' ')
    for i in range(12):
      sample[i] = float(splitLine[i])
    data.append(sample)
    
  matrix = mat(data)
  L = len(data)
  tests[k] = L
  yM = eval(short[k]+'Model.eval(data)')
  yA = eval(short[k]+'Anti.eval(data)')
    
  for i in range(L):
    if (yM[0][i] - yA[0][i]) < bestR[k]:
      approved[k] += 1
       
for i in range(N):
  accuracy2[i] = float(approved[i])/tests[i]
  
print accuracy2

average_error = numpy.zeros(N)

for i in range(N):
  average_error[i] = ( 2 - accuracy1[i]-accuracy2[i] ) / 2
  
totEerSum = 0

for i in range(N):
  totEerSum += average_error[i]
  
totAvgEer = totEerSum / N

print average_error
print 'Average EER: '+str(totAvgEer)