#Make GMM model using EM-algorithm
#Choose which attribute to train and what number of components to evaluate
#Will train the model which have the lowest BIC score

import os, numpy, math, pickle
from numpy import zeros,sign,mat
from sklearn import mixture

languages = ['arabic', 'english', 'farsi', 'french', 'german', 'hindi', 'japanese', 'korean', 'mandarin', 'spanish', 'tamil', 'vietnamese']
short = ['ar', 'en', 'fa', 'fr', 'ge', 'hi', 'ja', 'ko', 'ma', 'sp', 'ta', 'vi']
langMapper = {'arabic':0, 'english':1, 'farsi':2, 'french':3, 'german':4, 'hindi':5, 'japanese':6, 'korean':7, 'mandarin':8, 'spanish':9, 'tamil':10, 'vietnamese':11}
N= len(languages)

L = '200'
#attrib = 'manner'
#attrib = 'place'
attrib = 'combine'

classes = ['Model', 'Anti']

#number of mixture components
n_components_range = [1,11]
#n_components_range = range(1,10)

#Covariance matrix
cv_types = ['full']

    
for k in range(N):
  for r in range(2):
    
    data = []
    f = open('../distances/'+L+'/'+attrib+'/train/'+short[k]+classes[r]+'.txt','r')
    for line in f:
      sample = numpy.zeros(N)
      splitLine = line.split(' ')
      for i in range(N):
        sample[i] = float(splitLine[i])
      data.append(sample)
    f.close()
    matrix = mat(data)
    
    lowest_bic = numpy.infty
    bic = []
    for cv_type in cv_types:
      for n_components in n_components_range:
          # Fit a mixture of gaussians with EM
          gmm = mixture.GMM(n_components=n_components, covariance_type=cv_type)
          gmm.fit(matrix)
          bic.append(gmm.bic(matrix))
          if bic[-1] < lowest_bic:
              lowest_bic = bic[-1]
              best_gmm = gmm
              comps = n_components
              covarTyp = cv_type
         
    vars()[short[k]+classes[r]] = best_gmm
    filehandler = open('gmms/'+attrib+'/'+short[k]+classes[r],'w') 
    pickle.dump(best_gmm,filehandler)

    print 'Made model for '+languages[k]+' '+classes[r]+', covariance: '+covarTyp+', components: '+str(comps)


