'''
Make files which are used for training SVD classifier for combined features
'''

import os
import math
from numpy import linalg, dot
import numpy
import random

languages = [ 'arabic', 'english', 'farsi', 'french', 'german', 'hindi', 'japanese', 'korean', 'mandarin', 'spanish', 'tamil', 'vietnamese' ]
#languages = [ 'spanish' ]

attribM = ['affricate', 'fric', 'nasal', 'vowel', 'vstop', 'uvstop', 'glide', 'liquid', 'diph', 'sibilant', 'flap', 'sil' ]
attribP = ['alveolar', 'alvpal', 'dental', 'glottal', 'high', 'bilabial', 'labiodental', 'low', 'mid', 'palatal', 'velar', 'sil']
Umatrix = []

R = 10

attributeM = 'manner'
attributeP = 'place'
file = open('matrix/Umatrix40.txt', 'r')

filedir = 'devtest'
#filedir = 'evltest'

totCount = 0
segLength = 30
maxLength = segLength*10000000
ngramOrder = 4
totNgrams = 0
split = '.'
for x in range(ngramOrder):
  totNgrams += int(math.pow(len(attribM),x+1))

emptyCounterM = {}
emptyCounterP = {}

for v in range(ngramOrder):
  if v == 0:
    for w in range(len(attribM)):
      ngramM = attribM[w]
      ngramP = attribP[w]
      emptyCounterM[ngramM] = 0
      emptyCounterP[ngramP] = 0
      continue
  if v == 1:
    for w in range(len(attribM)):
      for x in range(len(attribM)):
        ngramM = attribM[w] + split + attribM[x]
        ngramP = attribP[w] + split + attribP[x]
        emptyCounterM[ngramM] = 0
        emptyCounterP[ngramP] = 0
        continue
  if v == 2:
    for w in range(len(attribM)):
      for x in range(len(attribM)):
        for y in range(len(attribM)):
          ngramM = attribM[w] + split + attribM[x] + split + attribM[y]
          ngramP = attribP[w] + split + attribP[x] + split + attribP[y]
          emptyCounterM[ngramM] = 0
          emptyCounterP[ngramP] = 0
          continue
  if v == 3:
    for w in range(len(attribM)):
      for x in range(len(attribM)):
        for y in range(len(attribM)):
          for z in range(len(attribM)):
            ngramM = attribM[w] + split + attribM[x] + split + attribM[y] + split + attribM[z]
            ngramP = attribP[w] + split + attribP[x] + split + attribP[y] + split + attribP[z]
            emptyCounterM[ngramM] = 0
            emptyCounterP[ngramP] = 0

def updateManner(manner,feature):
  if manner.has_key(feature):
    manner[feature] += 1
  else:
    print feature
    print 'WTF!'

def isSilence(feature):
  return feature == 'sil'

def dict2vectM(testDoc):
  d = numpy.zeros(totNgrams)
  r=0
  for v in range(ngramOrder):
    if v == 0:
      for w in range(len(attribM)):
        ngram = attribM[w]
        d[r] = testDoc[ngram]
        r += 1

    elif v == 1:
      for w in range(len(attribM)):
        for x in range(len(attribM)):
          ngram = attribM[w] + split + attribM[x]
          d[r] = testDoc[ngram]
          r += 1

    elif v == 2:
      for w in range(len(attribM)):
        for x in range(len(attribM)):
          for y in range(len(attribM)):
            ngram = attribM[w] + split + attribM[x] + split + attribM[y]
            d[r] = testDoc[ngram]
            r += 1

    elif v == 3:
      for w in range(len(attribM)):
        for x in range(len(attribM)):
          for y in range(len(attribM)):
            for z in range(len(attribM)):
              ngram = attribM[w] + split + attribM[x] + split + attribM[y] + split + attribM[z]
              d[r] = testDoc[ngram]
              r += 1
#  print str(r)+' jeij!'
  return d

def dict2vectP(testDoc):
  d = numpy.zeros(totNgrams)
  r=0
  for v in range(ngramOrder):
    if v == 0:
      for w in range(len(attribP)):
        ngram = attribP[w]
        d[r] = testDoc[ngram]
        r += 1

    elif v == 1:
      for w in range(len(attribP)):
        for x in range(len(attribP)):
          ngram = attribP[w] + split + attribP[x]
          d[r] = testDoc[ngram]
          r += 1

    elif v == 2:
      for w in range(len(attribP)):
        for x in range(len(attribP)):
          for y in range(len(attribP)):
            ngram = attribP[w] + split + attribP[x] + split + attribP[y]
            d[r] = testDoc[ngram]
            r += 1

    elif v == 3:
      for w in range(len(attribP)):
        for x in range(len(attribP)):
          for y in range(len(attribP)):
            for z in range(len(attribP)):
              ngram = attribP[w] + split + attribP[x] + split + attribP[y] + split + attribP[z]
              d[r] = testDoc[ngram]
              r += 1
#  print str(r)+' jeij!'
  return d
  
def count2prob(dCount):
  N = len(attribM)
  a = int(N)
  b = int(math.pow(N,2))
  c = int(math.pow(N,3))
  d = int(math.pow(N,4))

  dProb = numpy.zeros(len(dCount))
  for r in range(a):
    dProb[r] = float(dCount[r])/totCount[0]

  for r in range(a,a+b):
    dProb[r] = float(dCount[r])/totCount[1]

  for r in range(a+b,a+b+c):
    dProb[r] = float(dCount[r])/totCount[2]

  for r in range(a+b+c, a+b+c+d):
    dProb[r] = float(dCount[r])/totCount[3]

  return dProb
      
def evaluate(Umatrix, d):
  v = []
  v = dot(d,Umatrix)
#    print v.shape

  return v

def fileOutWrite(vVectors,k):
  modelMatrix[k].append(vVectors)

Umatrix = numpy.zeros((totNgrams*2,R))
i = 0
for line in file:
  splitLine = line.split(' ')
  for j in range(R):
    Umatrix[i][j] = float(splitLine[j])
  i += 1
#  print str(i)

docSumsM = []
countMatrixManner = []
countMatrixPlace = []
labelsManner = []
labelsPlace = []
timing = []  
sumCue = 0
##Counting manners
for k in range(len(languages)):
  testdir = 'CallFriend/'+languages[k]+'/transcripts/manner/'+filedir+'/'+filedir+'_sorted.txt'
  totCount = [0, 0, 0, 0] 
  file = open(testdir, 'r')
  testDoc = emptyCounterM.copy()
  counter = 0
  lastfeatures = ['sil']
  sumCount = 0
  cue = [0,0]
  print len(labelsManner)

  for line in file:
   splitLine = line.split(' ')

   if len(splitLine) >= 4:
     feature = splitLine[2]

     if feature != 'sil':
       counter += int(splitLine[1]) - int(splitLine[0])
       sumCount += int(splitLine[1]) - int(splitLine[0])
 
     lastfeatures.insert(0,feature)
     if len(lastfeatures) > ngramOrder:
       lastfeatures.pop(ngramOrder)
     
     if int(splitLine[0]) == 0:
       cue[1] = 0
       cue[0] += 1

     if isSilence(feature):
       cue[1] += 1

     if isSilence(feature) and isSilence(lastfeatures[1]):
       lastfeatures.pop(0)
     else:
       xgram = ''

       for j in range(len(lastfeatures)):
         if j == 0:
           xgram = lastfeatures[j]
         else:
           xgram = lastfeatures[j]+split+xgram
         updateManner(testDoc,xgram)
         totCount[j] += 1


#     if isSilence(feature):
#       lastfeatures = ['sil']

     if counter > maxLength and feature == 'sil':
       if totCount[0] == 0 or totCount[3] == 0:
         totCount = [1,1,1,1]

       dcount = dict2vectM(testDoc)
       dprobs = count2prob(dcount)
       countMatrixManner.append(dprobs)
       labelsManner.append(k)
       docSumsM.append(totCount)

       timing.append(cue)
       cue = [0,0]

       counter = 0
       testDoc = emptyCounterM.copy()
       totCount = [0,0,0,0]

   else:
     lastfeatures = ['sil']
     counter = 0
     totCount = [0,0,0,0]
     testDoc = emptyCounterM.copy()
     cue = [0,0]

  print 'Finished counting manner files for '+languages[k]

print len(labelsManner)

##Counting place
timeIdx = 0
docSumsP = []

for k in range(len(languages)):
  testdir = 'CallFriend/'+languages[k]+'/transcripts/place/'+filedir+'/'+filedir+'_sorted.txt'
  
  totCount = [0, 0, 0, 0] 
  file = open(testdir, 'r')
  testDoc = emptyCounterP.copy()
  counter = 0
  lastfeatures = ['sil']
  sumCount = 0
  cue = [0,0]
  print len(labelsPlace)

  for line in file:
   if timeIdx > len(labelsManner)-1:
     break
   if labelsManner[timeIdx] != k:
     break

   splitLine = line.split(' ')

   if len(splitLine) >= 4:
     feature = splitLine[2]

     if feature != 'sil':
       counter += int(splitLine[1]) - int(splitLine[0])
       sumCount += int(splitLine[1]) - int(splitLine[0])
 
     lastfeatures.insert(0,feature)
     if len(lastfeatures) > ngramOrder:
       lastfeatures.pop(ngramOrder)

     if splitLine[0] == '0':
       sumCue += 1
       cue[1] = 0
       cue[0] += 1
     if isSilence(feature):
       cue[1] += 1

     if isSilence(feature) and isSilence(lastfeatures[1]):
       lastfeatures.pop(0)
     else:

       xgram = ''

       for j in range(len(lastfeatures)):
         if j == 0:
           xgram = lastfeatures[j]
         else:
           xgram = lastfeatures[j]+split+xgram
         updateManner(testDoc,xgram)
         totCount[j] += 1


#     if isSilence(feature):
#       lastfeatures = ['sil']

     if cue[0] == timing[timeIdx][0]:
       if totCount[0] == 0 or totCount[3] == 0:
         totCount = [1,1,1,1]

       dcount = dict2vectP(testDoc)
       dprobs = count2prob(dcount)
       countMatrixPlace.append(dprobs)
       labelsPlace.append(k)
       docSumsP.append(totCount)
              
       counter = 0
       testDoc = emptyCounterP.copy()
       totCount = [0,0,0,0]
       cue = [0,0]
       timeIdx += 1

   else:
     lastfeatures = ['sil']
     counter = 0
     totCount = [0,0,0,0]
     testDoc = emptyCounterP.copy()
     cue = [0,0]

  print 'Finished counting place files for '+languages[k]

print len(labelsPlace)

modelMatrix = []
for k in range(len(languages)):
  model = []
  modelMatrix.insert(k,model)


z = 0
for w in range(timeIdx):
  d = numpy.zeros(totNgrams*2)
  for r in range(totNgrams):
    d[r] = countMatrixManner[w][r]
    d[r+totNgrams] = countMatrixPlace[w][r]
  vVectors = evaluate(Umatrix,d)
  fileOutWrite(vVectors,labelsManner[w])
  z +=1

print 'Total tests: '+str(z)+', rejected '+str(timeIdx-z)+' files'

for k in range(len(languages)):

  outdir = 'CallFriend/'+languages[k]+'/docVectors/combine/'+filedir+'/'
  fileOut = open(outdir+filedir+'Doc.txt','w')
  M = len(modelMatrix[k])
  for i in range(M):
    fileOut.write('+1')
    for j in range(len(modelMatrix[k][i])):
      fileOut.write(' '+str(j+1)+':'+str(modelMatrix[k][i][j]))
    if i == M-1:
      break
    fileOut.write('\n')
  print 'Written data to file for '+languages[k]
