#Make test files for combined NIST files

import os
import math
from numpy import linalg, dot
import numpy
import random

attribM = ['affricate', 'fric', 'nasal', 'vowel', 'vstop', 'uvstop', 'glide', 'liquid', 'diph', 'sibilant', 'flap', 'sil' ]
attribP = ['alveolar', 'alvpal', 'dental', 'glottal', 'high', 'bilabial', 'labiodental', 'low', 'mid', 'palatal', 'velar', 'sil' ]

R = 10
file = open('matrix/Umatrix40.txt', 'r')

Umatrix = []

totCount = 0
ngramOrder = 4
totNgrams = 0
split = '.'
for x in range(ngramOrder):
  totNgrams += int(math.pow(len(attribM),x+1))

labelManner = {}
labelFile = open('NIST/manner/rec_lid03e1_30.lab')
for line in labelFile:
  splitLine = line.split(' ')
  labelManner[splitLine[0]] = splitLine[1].split('\n')[0]
  
labelPlace = {}
labelFile = open('NIST/place/rec_lid03e1_30.lab')
for line in labelFile:
  splitLine = line.split(' ')
  labelPlace[splitLine[0]] = splitLine[1].split('\n')[0]

emptyCounterM = {}
emptyCounterP = {}

for v in range(ngramOrder):
  if v == 0:
    for w in range(len(attribM)):
      ngramM = attribM[w]
      ngramP = attribP[w]
      emptyCounterM[ngramM] = 0
      emptyCounterP[ngramP] = 0
      continue
  if v == 1:
    for w in range(len(attribM)):
      for x in range(len(attribM)):
        ngramM = attribM[w] + split + attribM[x]
        ngramP = attribP[w] + split + attribP[x]
        emptyCounterM[ngramM] = 0
        emptyCounterP[ngramP] = 0
        continue
  if v == 2:
    for w in range(len(attribM)):
      for x in range(len(attribM)):
        for y in range(len(attribM)):
          ngramM = attribM[w] + split + attribM[x] + split + attribM[y]
          ngramP = attribP[w] + split + attribP[x] + split + attribP[y]
          emptyCounterM[ngramM] = 0
          emptyCounterP[ngramP] = 0
          continue
  if v == 3:
    for w in range(len(attribM)):
      for x in range(len(attribM)):
        for y in range(len(attribM)):
          for z in range(len(attribM)):
            ngramM = attribM[w] + split + attribM[x] + split + attribM[y] + split + attribM[z]
            ngramP = attribP[w] + split + attribP[x] + split + attribP[y] + split + attribP[z]
            emptyCounterM[ngramM] = 0
            emptyCounterP[ngramP] = 0

def updateManner(manner,feature):
  if manner.has_key(feature):
    manner[feature] += 1
  else:
    print feature
    print 'WTF!'

def isSilence(feature):
  return feature == 'sil'

def dict2vectM(testDoc):
  d = numpy.zeros(totNgrams)
  r=0
  for v in range(ngramOrder):
    if v == 0:
      for w in range(len(attribM)):
        ngram = attribM[w]
        d[r] = testDoc[ngram]
        r += 1

    elif v == 1:
      for w in range(len(attribM)):
        for x in range(len(attribM)):
          ngram = attribM[w] + split + attribM[x]
          d[r] = testDoc[ngram]
          r += 1

    elif v == 2:
      for w in range(len(attribM)):
        for x in range(len(attribM)):
          for y in range(len(attribM)):
            ngram = attribM[w] + split + attribM[x] + split + attribM[y]
            d[r] = testDoc[ngram]
            r += 1

    elif v == 3:
      for w in range(len(attribM)):
        for x in range(len(attribM)):
          for y in range(len(attribM)):
            for z in range(len(attribM)):
              ngram = attribM[w] + split + attribM[x] + split + attribM[y] + split + attribM[z]
              d[r] = testDoc[ngram]
              r += 1
#  print str(r)+' jeij!'
  return d

def dict2vectP(testDoc):
  d = numpy.zeros(totNgrams)
  r=0
  for v in range(ngramOrder):
    if v == 0:
      for w in range(len(attribP)):
        ngram = attribP[w]
        d[r] = testDoc[ngram]
        r += 1

    elif v == 1:
      for w in range(len(attribP)):
        for x in range(len(attribP)):
          ngram = attribP[w] + split + attribP[x]
          d[r] = testDoc[ngram]
          r += 1

    elif v == 2:
      for w in range(len(attribP)):
        for x in range(len(attribP)):
          for y in range(len(attribP)):
            ngram = attribP[w] + split + attribP[x] + split + attribP[y]
            d[r] = testDoc[ngram]
            r += 1

    elif v == 3:
      for w in range(len(attribP)):
        for x in range(len(attribP)):
          for y in range(len(attribP)):
            for z in range(len(attribP)):
              ngram = attribP[w] + split + attribP[x] + split + attribP[y] + split + attribP[z]
              d[r] = testDoc[ngram]
              r += 1
#  print str(r)+' jeij!'
  return d
  
def count2prob(dCount):
  N = len(attribM)
  a = int(N)
  b = int(math.pow(N,2))
  c = int(math.pow(N,3))
  d = int(math.pow(N,4))

  dProb = numpy.zeros(len(dCount))
  for r in range(a):
    dProb[r] = float(dCount[r])/totCount[0]

  for r in range(a,a+b):
    dProb[r] = float(dCount[r])/totCount[1]

  for r in range(a+b,a+b+c):
    dProb[r] = float(dCount[r])/totCount[2]

  for r in range(a+b+c, a+b+c+d):
    dProb[r] = float(dCount[r])/totCount[3]

  return dProb
      
def evaluate(Umatrix, d):
  v = []
  v = dot(d,Umatrix)
#    print v.shape

  return v

def fileOutWrite(vVectors):
  modelMatrix.append(vVectors)

Umatrix = numpy.zeros((totNgrams*2,R))
i = 0
for line in file:
  splitLine = line.split(' ')
  for j in range(R):
    Umatrix[i][j] = float(splitLine[j])
  i += 1
#  print str(i)

modelMatrix = []

index = []
mannerVect = {}
placeVect = {}
for k in range(1):
  testdir = 'NIST/manner/lid03e1_30_sorted.txt'
  
  totCount = [0, 0, 0, 0] 
  totTests = 0
  file = open(testdir, 'r')
  testDoc = emptyCounterM.copy()
  lastfeatures = ['sil']
  sumCount = 0
  counter = 0 
  r = 0

  for line in file:
   splitLine = line.split(' ')

   if len(splitLine) >= 4:
     feature = splitLine[2]

     if feature != 'sil':
       counter += int(splitLine[1]) - int(splitLine[0])
       sumCount += int(splitLine[1]) - int(splitLine[0])
 
     lastfeatures.insert(0,feature)
     if len(lastfeatures) > ngramOrder:
       lastfeatures.pop(ngramOrder)

     if isSilence(feature) and isSilence(lastfeatures[1]):
       lastfeatures = ['sil']
       continue

     xgram = ''

     for j in range(len(lastfeatures)):
       if j == 0:
         xgram = lastfeatures[j]
       else:
         xgram = lastfeatures[j]+split+xgram
       updateManner(testDoc,xgram)
       totCount[j] += 1


#     if isSilence(feature):
#       lastfeatures = ['sil']

   elif len(splitLine) == 1 and counter != 0:
     totTests += 1
     dcount = dict2vectM(testDoc)
     dprobs = count2prob(dcount)
     mannerVect[filename] = dprobs
     
     lineT = line.split('/')
     splitLine = lineT[1].split('\n') 
     index.insert(r,splitLine[0])
     filename = splitLine[0]
     r += 1
     print ('starting processing '+index[r-1]+', r = '+str(r))
   
     counter = 0
     testDoc = emptyCounterM.copy()
     totCount = [0,0,0,0]

   elif len(splitLine) == 1 and counter == 0:
     lineT = line.split('/')
     splitLine = lineT[1].split('\n')
     index.insert(r,splitLine[0])
     filename = splitLine[0]
     r += 1
     print ('starting processing '+index[r-1]+', r = '+str(r))
   else:
     print line

  totTests += 1
  dcount = dict2vectM(testDoc)
  dprobs = count2prob(dcount)
  mannerVect[filename] = dprobs

  print 'Finished counting manners for NIST set'

for k in range(1):
  testdir = 'NIST/place/lid03e1_30_sorted.txt'
  
  totCount = [0, 0, 0, 0] 
  totTests = 0
  file = open(testdir, 'r')
  testDoc = emptyCounterP.copy()
  lastfeatures = ['sil']
  sumCount = 0
  counter = 0 
  r = 0

  for line in file:
   splitLine = line.split(' ')

   if len(splitLine) >= 4:
     feature = splitLine[2]

     if feature != 'sil':
       counter += int(splitLine[1]) - int(splitLine[0])
       sumCount += int(splitLine[1]) - int(splitLine[0])
 
     lastfeatures.insert(0,feature)
     if len(lastfeatures) > ngramOrder:
       lastfeatures.pop(ngramOrder)

     if isSilence(feature) and isSilence(lastfeatures[1]):
       lastfeatures = ['sil']
       continue

     xgram = ''

     for j in range(len(lastfeatures)):
       if j == 0:
         xgram = lastfeatures[j]
       else:
         xgram = lastfeatures[j]+split+xgram
       updateManner(testDoc,xgram)
       totCount[j] += 1


#     if isSilence(feature):
#       lastfeatures = ['sil']

   elif len(splitLine) == 1 and counter != 0:
     totTests += 1
     dcount = dict2vectP(testDoc)
     dprobs = count2prob(dcount)
     placeVect[filename] = dprobs
     
     lineT = line.split('/')
     splitLine = lineT[1].split('\n') 
#     index.insert(r,splitLine[0])	#index is used to match transcriptions, already listed in manner
     filename = splitLine[0]
     r += 1
     print ('starting processing '+index[r-1]+', r = '+str(r))
   
     counter = 0
     testDoc = emptyCounterP.copy()
     totCount = [0,0,0,0]

   elif len(splitLine) == 1 and counter == 0:
     lineT = line.split('/')
     splitLine = lineT[1].split('\n')
#     index.insert(r,splitLine[0])
     filename = splitLine[0]
     r += 1
     print ('starting processing '+index[r-1]+', r = '+str(r))
   else:
     print line

  totTests += 1
  dcount = dict2vectP(testDoc)
  dprobs = count2prob(dcount)
  placeVect[filename] = dprobs

  print 'Finished counting manners for NIST set'

for r in range(len(index)):
  docVect = numpy.zeros(totNgrams*2)
  for i in range(totNgrams):
    docVect[i] = mannerVect[index[r]][i]
    docVect[i+totNgrams] = placeVect[index[r]][i]
  vVectors = evaluate(Umatrix,docVect)
  fileOutWrite(vVectors)
  

for k in range(1):

  outdir = 'NIST/combine/'
  fileOut = open(outdir+'combineDoc.txt','w')
  M = len(modelMatrix)
  for i in range(M):
    fileOut.write('+1')
    for j in range(len(modelMatrix[i])):
      fileOut.write(' '+str(j+1)+':'+str(modelMatrix[i][j]))
    if i == M-1:
      break
    fileOut.write('\n')

  fileIndex = open(outdir+'labels.txt', 'w')
  for i in range(1280):
    fileIndex.write(index[i]+' '+labelManner[index[i]])
    if i == 1279:
      break
    fileIndex.write('\n')

  print 'Written data to file for NIST'
