#used to make devtest and evltest files for manner and place

import os
import math
from numpy import linalg, dot
import numpy
import random

languages = [ 'arabic', 'english', 'farsi', 'french', 'german', 'hindi', 'japanese', 'korean', 'mandarin', 'spanish', 'tamil', 'vietnamese' ]
#languages = [ 'english', 'french' ]

#attrib = ['affricate', 'fric', 'nasal', 'vowel', 'vstop', 'uvstop', 'glide', 'liquid', 'diph', 'sibilant', 'flap', 'sil' ]
attrib = ['alveolar', 'alvpal', 'dental', 'glottal', 'high', 'bilabial', 'labiodental', 'low', 'mid', 'palatal', 'velar', 'sil']
Umatrix = []

#attribute = 'manner'
attribute = 'place'
file = open('matrix/UmatrixPlace40.txt', 'r')

R = 10
testDir = 'devtest'
#testDir = 'evltest'

totCount = 0
segLength = 30
maxLength = segLength*10000000
ngramOrder = 4
totNgrams = 0
split = '.'
for x in range(ngramOrder):
  totNgrams += math.pow(len(attrib),x+1)

emptyCounter = {}

for v in range(ngramOrder):
  if v == 0:
    for w in range(len(attrib)):
      ngram = attrib[w]
      emptyCounter[ngram] = 0
      continue
  if v == 1:
    for w in range(len(attrib)):
      for x in range(len(attrib)):
        ngram = attrib[w] + split + attrib[x]
        emptyCounter[ngram] = 0
        continue
  if v == 2:
    for w in range(len(attrib)):
      for x in range(len(attrib)):
        for y in range(len(attrib)):
          ngram = attrib[w] + split + attrib[x] + split + attrib[y]
          emptyCounter[ngram] = 0
          continue
  if v == 3:
    for w in range(len(attrib)):
      for x in range(len(attrib)):
        for y in range(len(attrib)):
          for z in range(len(attrib)):
            ngram = attrib[w] + split + attrib[x] + split + attrib[y] + split + attrib[z]
            emptyCounter[ngram] = 0

def updateManner(manner,feature):
  if manner.has_key(feature):
    manner[feature] += 1
  else:
    print feature
    print 'WTF!'

def isSilence(feature):
  return feature == 'sil'

def dict2vect(testDoc):
  d = numpy.zeros(totNgrams)
  r=0
  for v in range(ngramOrder):
    if v == 0:
      for w in range(len(attrib)):
        ngram = attrib[w]
        d[r] = testDoc[ngram]
        r += 1

    elif v == 1:
      for w in range(len(attrib)):
        for x in range(len(attrib)):
          ngram = attrib[w] + split + attrib[x]
          d[r] = testDoc[ngram]
          r += 1

    elif v == 2:
      for w in range(len(attrib)):
        for x in range(len(attrib)):
          for y in range(len(attrib)):
            ngram = attrib[w] + split + attrib[x] + split + attrib[y]
            d[r] = testDoc[ngram]
            r += 1

    elif v == 3:
      for w in range(len(attrib)):
        for x in range(len(attrib)):
          for y in range(len(attrib)):
            for z in range(len(attrib)):
              ngram = attrib[w] + split + attrib[x] + split + attrib[y] + split + attrib[z]
              d[r] = testDoc[ngram]
              r += 1
#  print str(r)+' jeij!'
  return d

def count2prob(dCount):
  N = len(attrib)
  a = int(N)
  b = int(math.pow(N,2))
  c = int(math.pow(N,3))
  d = int(math.pow(N,4))

  dProb = numpy.zeros(len(dCount))

  for r in range(a):
    dProb[r] = float(dCount[r])/totCount[0]

  for r in range(a,a+b):
    dProb[r] = float(dCount[r])/totCount[1]

  for r in range(a+b,a+b+c):
    dProb[r] = float(dCount[r])/totCount[2]

  for r in range(a+b+c, a+b+c+d):
    dProb[r] = float(dCount[r])/totCount[3]
 
  return dProb
      
def evaluate(Umatrix, d):
  v = []
  v = dot(d,Umatrix)
#    print v.shape

  return v

def fileOutWrite(vVectors,k):
  modelMatrix[k].append(vVectors)

Umatrix = numpy.zeros((totNgrams,R))
i = 0
for line in file:
  splitLine = line.split(' ')
  for j in range(R):
    Umatrix[i][j] = float(splitLine[j])
  i += 1
#  print str(i)

modelMatrix = []
for k in range(len(languages)):
  model = []
  modelMatrix.insert(k,model)

for k in range(len(languages)):
  test = 'CallFriend/'+languages[k]+'/transcripts/'+attribute+'/'+testDir+'/'+testDir+'_sorted.txt'
  
  totCount = [0, 0, 0, 0] 
  totTests = 0
  correct = 0
  wrongs = [0]*len(languages)
  file = open(test, 'r')
  testDoc = emptyCounter.copy()
  counter = 0
  lastfeatures = ['sil']
  sumCount = 0

  for line in file:
   splitLine = line.split(' ')

   if len(splitLine) >= 4:
     feature = splitLine[2]

     if feature != 'sil':
       counter += int(splitLine[1]) - int(splitLine[0])
       sumCount += int(splitLine[1]) - int(splitLine[0])
 
     lastfeatures.insert(0,feature)
     if len(lastfeatures) > ngramOrder:
       lastfeatures.pop(ngramOrder)

     if isSilence(feature) and isSilence(lastfeatures[1]):
       lastfeatures = ['sil']
       continue

     xgram = ''

     for j in range(len(lastfeatures)):
       if j == 0:
         xgram = lastfeatures[j]
       else:
         xgram = lastfeatures[j]+split+xgram
       updateManner(testDoc,xgram)
       totCount[j] += 1


#     if isSilence(feature):
#       lastfeatures = ['sil']

     if counter > maxLength:
       totTests += 1
       dcount = dict2vect(testDoc)
       dprobs = count2prob(dcount)
       vVectors = evaluate(Umatrix,dprobs)
       fileOutWrite(vVectors,k)
       counter = 0
       testDoc = emptyCounter.copy()
       totCount = [0,0,0,0]
#       print 'New test file ready'

   else:
     lastfeatures = ['sil']
     counter = 0
     totCount = [0,0,0,0]
     testDoc = emptyCounter.copy()
  print 'Finished processing '+languages[k]
print sumCount

for k in range(len(languages)):

  outdir = 'CallFriend/'+languages[k]+'/docVectors/'+attribute+'/'+testDir+'/'
  fileOut = open(outdir+testDir+'Doc.txt','w')
  M = len(modelMatrix[k])
  for i in range(M):
    fileOut.write('+1')
    for j in range(len(modelMatrix[k][i])):
      fileOut.write(' '+str(j+1)+':'+str(modelMatrix[k][i][j]))
    if i == M-1:
      break
    fileOut.write('\n')
  print 'Written data to file for '+languages[k]
