from numpy import linalg, mat, zeros
import numpy, math

#Merge W-matrices for manner and place, to generate U-matrix for combined features 
fileOut = open('matrix/Umatrix40.txt', 'w')

f = open('matrix/labelsManner40.txt','r')
g = open('matrix/labelsPlace40.txt','r')

labelsManner = f.read().split('\n')
labelsPlace = g.read().split('\n')
M = len(labelsManner)
N = len(labelsPlace)

print M-1
print N-1

ngramOrder = 4
totNgrams = 0
split = '.'
for x in range(ngramOrder):
  totNgrams += int(math.pow(12,x+1))

o = open('matrix/WmatrixPlace40.txt', 'r')
p = open('matrix/WmatrixManner40.txt', 'r')
print 'Read W-matrices!'

manner = numpy.zeros([totNgrams,M-1])
i = 0
for line in p:
  splitLine = line.split(' ')
  for j in range(M-1):
    manner[i][j] = float(splitLine[j])
  i += 1

Wmanner = mat(manner)
print Wmanner.shape

place = numpy.zeros([totNgrams,N-1])
i = 0
for line in o:
  splitLine = line.split(' ')
  for j in range(N-1):
    place[i][j] = float(splitLine[j])
  i += 1 
   
Wplace = mat(place)
print Wplace.shape

print 'Loaded Ws into arrays'

print manner[0][0]
print manner[0][1]
print manner[1][0]
print manner[2][0]
print '\n'
print place[0][0]
print place[0][1]
print place[1][0]
print place[2][0]

languages = ['arabic', 'english', 'farsi', 'french', 'german', 'hindi', 'japanese', 'korean', 'mandarin', 'spanish', 'tamil', 'vietnamese']

indexM = []
indexP = []
currentLang = languages[0]
i=0
j=0
while i < M-1 or j < N-1:
  if labelsManner[i] == labelsPlace[j]:
    indexM.append(i)
    indexP.append(j)
    i += 1
    j += 1
    currentLang = labelsManner[i]

  elif labelsManner[i] != currentLang:
    j += 1
  elif labelsPlace[j] != currentLang:
    i += 1

L = len(indexM)
matrix = numpy.zeros([totNgrams*2,L])

for i in range(L):
  m = indexM[i]
  p = indexP[i]
  for r in range(totNgrams):
    matrix[r][i] = manner[r][m]
    matrix[r+totNgrams][i] = place[r][p]
    
  print 'Inserted '+str(i+1)+' of '+str(L)+' columns to final matrix'

print '\n'
print matrix[0][0]
print matrix[0][1]
print matrix[1][0]
print matrix[2][0]
print '\n'
print matrix[totNgrams][0]
print matrix[totNgrams][1]
print matrix[totNgrams+1][0]
print matrix[totNgrams+2][0]

print 'Starting SVD'
U = numpy.zeros((totNgrams*2,totNgrams*2))
s = numpy.zeros((totNgrams*2,L))
V = numpy.zeros((L,L))
U, s, V = linalg.svd(matrix,0)

print 'Finished SVD'
#print U
#  print s

dimensions = 10000
rows, cols = matrix.shape
'''
if cols > rows:
  axis = 1
  dim = rows
  R = len(s)
  Q = len(V)-len(s)
else:
  axis = 0
  dim = cols
  R = len(U)-len(s)
  Q = len(s)

  #Dimension reduction
for i in range(dimensions,dim):
  s[i] = 0

s = numpy.diag(s,0)

if cols != rows:
  padding = numpy.zeros((R,Q))
  sigma = numpy.append(s,padding,axis)
else:
  sigma = s

print U.shape
print sigma.shape
print V.shape
print 'Reconstructed W'
recW = dot(dot(U,sigma),V)

for c in range(rows):
  for e in range(cols):
    diff = matrix[c][e]-recW[c][e]
    if math.fabs(diff) >= math.pow(10,-14):
      print 'Trololololol: '+str(diff)
'''
Urows, Ucols = U.shape
R = 450
for f in range(Urows):
  for g in range(R):
    fileOut.write(str(U[f][g])+' ')
  fileOut.write('\n')

print 'Finished LSA'
