'''
Makes one U-matrix where all languages are included for manner data
'''

import os
import math
from numpy import linalg, dot
import numpy

languages = [ 'arabic', 'english', 'farsi', 'french', 'german', 'hindi', 'japanese', 'korean', 'mandarin', 'spanish', 'tamil', 'vietnamese' ]
#languages = [ 'french', 'german']
transcriptdirs= ['train']
targetdirs =  'VSM' 
split = '.'

attrib = ['affricate', 'fric', 'nasal', 'vowel', 'vstop', 'uvstop', 'glide', 'liquid', 'diph', 'sibilant', 'flap', 'sil']
#attrib = ['alveolar', 'alvpal', 'dental', 'glottal', 'high', 'bilabial', 'labiodental', 'low', 'mid', 'palatal', 'velar', 'sil']
labels = open('matrix/labelsManner40.txt', 'w')
fileOut = open('matrix/UmatrixManner40.txt','w')  
fileOut2 = open('matrix/WmatrixManner40.txt','w')


documentSec = 40
documentMaxLength = documentSec*10000000

ngramOrder = 4
totAttribs = len(attrib)
totNgrams = 0
for x in range(ngramOrder):
  totNgrams += math.pow(totAttribs,x+1)

emptyCounter = {}

for v in range(ngramOrder):
  if v == 0:
    for w in range(len(attrib)):
      ngram = attrib[w]
      emptyCounter[ngram] = 0
      continue
  if v == 1:
    for w in range(len(attrib)):
      for x in range(len(attrib)):
        ngram = attrib[w] + split + attrib[x]
        emptyCounter[ngram] = 0
        continue
  if v == 2:
    for w in range(len(attrib)):
      for x in range(len(attrib)):
        for y in range(len(attrib)):
          ngram = attrib[w] + split + attrib[x] + split + attrib[y]
          emptyCounter[ngram] = 0
          continue
  if v == 3:
    for w in range(len(attrib)):
      for x in range(len(attrib)):
        for y in range(len(attrib)):
          for z in range(len(attrib)):
            ngram = attrib[w] + split + attrib[x] + split + attrib[y] + split + attrib[z]  
            emptyCounter[ngram] = 0

def updateManner(manner,feature):
  if manner.has_key(feature) and termSum.has_key(feature):
    manner[feature] += 1
    termSum[feature] += 1
  else:
    print feature
    print 'WTF!'

def isSilence(feature):
  return feature == 'sil'

index = 0
totCount = 0
manners = [] #Store occurences of ngrams
trainDoc = emptyCounter.copy()
termSum = emptyCounter.copy()
termSumCopy = emptyCounter.copy()
documentSum = []
labelsManner= []
sum = [0, 0, 0, 0]


for k in range(len(languages)):
  sum = [0,0,0,0]
  counter = 0
  print len(manners)
  for i in range(len(transcriptdirs)):  
    basedir = './CallFriend/'+languages[k]+'/transcripts/manner/'+transcriptdirs[i]+'/'
#    basedir = './CallFriend/'+languages[k]+'/transcripts/place/'+transcriptdirs[i]+'/'
    
    file = open(basedir+transcriptdirs[i]+'_sorted.txt', 'r')

    lastfeatures = ['sil']

    for line in file:
      splitline = line.split(' ')
        
      if len(splitline) >= 4:
        feature = splitline[2]
        
        if feature != 'sil':
          counter += int(splitline[1]) - int(splitline[0])
          totCount += int(splitline[1]) - int(splitline[0])
        
        lastfeatures.insert(0,feature)
        if len(lastfeatures) > ngramOrder:
          lastfeatures.pop(ngramOrder)

        if isSilence(feature) and isSilence(lastfeatures[1]):
          lastfeatures = ['sil']
        else:

          xgram = ''
  
          for j in range(len(lastfeatures)):
            if j == 0:
              xgram = lastfeatures[j]
            else:
              xgram = lastfeatures[j]+split+xgram
            updateManner(trainDoc,xgram)
            sum[j] += 1


#        if isSilence(feature):
#          lastfeatures = ['sil']
       
        if counter > documentMaxLength and feature == 'sil' :
          termSumCopy = termSum.copy()
          manners.insert(index, trainDoc)
          trainDoc = emptyCounter.copy()
          labelsManner.append(k)

          documentSum.insert(index,sum)
          index += 1
          counter = 0
          sum = [0, 0, 0, 0]
         
      else:
        counter = 0
        sum = [0, 0, 0, 0]
        termSum = termSumCopy.copy()
        trainDoc = emptyCounter.copy()
        lastfeatures = ['sil']

    sum = [0,0,0,0]
    counter = 0
    termSum = termSumCopy.copy()
    trainDoc = emptyCounter.copy()
    lastfeatures = ['sil']
    
  print 'Read all files for '+languages[k]  
print 'Finished counting n-grams, so far so good!'
print index
print totCount
N = index

Wmatrix = []
b = 0
for k in range(N):
  Wcolumn = emptyCounter.copy()

  if documentSum[k][0] > 150:
    f = int(labelsManner[k])
    labels.write(languages[f]+'\n')
    for key, value in manners[k].items():
      if value == 0 or termSum[key] == 0:
        Wcolumn[key] = 0
      else:
        temp = 0
        for x in range(N):
          if manners[x][key] == 0:
            continue
          else:
            temp += float(manners[x][key])*(math.log(manners[x][key])-math.log(termSum[key]))
      
        g = len(key.split('.'))-1
      
        Wcolumn[key] = (1+1./math.log(N)*temp/termSum[key])*float(value)/documentSum[k][g]
    Wmatrix.insert(b, Wcolumn)
    b += 1
  print 'Inserted '+str(k+1)+' of '+str(N)+' columns!'  
print 'Finished normalizing entropies, so far so good!'
print 'Storing W-values into matrix and text file:'
labels.close()  
#  os.system('mkdir -p '+resultdir)
 
matrix = numpy.zeros((totNgrams,N))
r=0
for v in range(ngramOrder):
  if v == 0:
    for w in range(len(attrib)):
      ngram = attrib[w]
      for k in range(b):
        fileOut2.write(str(Wmatrix[k][ngram])+' ')
        matrix[r][k] = Wmatrix[k][ngram]
      r += 1 
      fileOut2.write('\n')           


  if v == 1:
    for w in range(len(attrib)):
      for x in range(len(attrib)):
        ngram = attrib[w] + split + attrib[x]
        for k in range(b):
          fileOut2.write(str(Wmatrix[k][ngram])+' ')
          matrix[r][k] = Wmatrix[k][ngram]
        r += 1
        fileOut2.write('\n')           
          
  if v == 2:
    for w in range(len(attrib)):
      for x in range(len(attrib)):
        for y in range(len(attrib)):
          ngram = attrib[w] + split + attrib[x] + split + attrib[y]
          for k in range(b):
            fileOut2.write(str(Wmatrix[k][ngram])+' ')
            matrix[r][k] = Wmatrix[k][ngram]
          r += 1
          fileOut2.write('\n')           
            

  if v == 3: 
    for w in range(len(attrib)):
      for x in range(len(attrib)):
        for y in range(len(attrib)):
          for z in range(len(attrib)):
            ngram = attrib[w] + split + attrib[x] + split + attrib[y] + split + attrib[z]
            for k in range(b):
              fileOut2.write(str(Wmatrix[k][ngram])+' ')
              matrix[r][k] = Wmatrix[k][ngram]
            r += 1
            fileOut2.write('\n')           

fileOut2.close() 
print 'Finished counting and weighting N-grams'
print r  
print matrix.shape

print 'number of columns: '+str(b)
print 'Starting SVD'
U = numpy.zeros((totNgrams,totNgrams))
s = numpy.zeros((totNgrams,N))
V = numpy.zeros((N,N))
U, s, V = linalg.svd(matrix,0)
  
print 'Finished SVD'
#print U 
#  print s

Urows, Ucols = U.shape
R = 400
for f in range(Urows):
  for g in range(R):
    fileOut.write(str(U[f][g])+' ')
  fileOut.write('\n')
''' 
dimensions = 10000
rows, cols = matrix.shape
  
if cols > rows:
  axis = 1
  dim = rows
  R = len(s)
  Q = len(V)-len(s)
else:
  axis = 0
  dim = cols
  R = len(U)-len(s)
  Q = len(s)
 
  #Dimension reduction
for i in range(dimensions,dim):
  s[i] = 0
  
s = numpy.diag(s,0)
  
if cols != rows:
  padding = numpy.zeros((R,Q))
  sigma = numpy.append(s,padding,axis)
else:
  sigma = s

print U.shape
print sigma.shape
print V.shape
print 'Reconstructed W'
recW = dot(dot(U,sigma),V)
  
for c in range(rows):
  for e in range(cols):
    diff = matrix[c][e]-recW[c][e]
    if math.fabs(diff) >= math.pow(10,-14):
      print 'Trololololol: '+str(diff)
'''    
print 'Finished LSA'
