#extract distances from hyperplane and store in distances-folder
#for NIST data

import os, numpy, math
from numpy import zeros,sign
from svmutil import *

languages = ['arabic', 'english', 'farsi', 'french', 'german', 'hindi', 'japanese', 'korean', 'mandarin', 'spanish', 'tamil', 'vietnamese']
short = ['ar', 'en', 'fa', 'fr', 'ge', 'hi', 'ja', 'ko', 'ma', 'sp', 'ta', 'vi']
langMapper = {'arabic':0, 'english':1, 'farsi':2, 'french':3, 'german':4, 'hindi':5, 'japanese':6, 'korean':7, 'mandarin':8, 'spanish':9, 'tamil':10, 'vietnamese':11}
oosLang = 'russian'  #Out-of-set-language

N = len(languages)
totTests = 0
tests = zeros(N)

S = '200'
attribute = 'manner'
#attribute = 'place'
#attribute = 'combine'

for i in range(N):
  vars()[short[i]+'Model'] = svm_load_model('models/'+S+'/'+attribute+'/'+short[i]+'.model')

Models = []
AntiModels = []
for k in range(N):
  model = []
  anti = []
  Models.insert(k,model)
  AntiModels.insert(k,anti)

for k in range(1): #N
  
  y ,x = svm_read_problem('NIST/'+S+'/'+attribute+'/NISTdoc')
  labels = open('NIST/'+S+'/'+attribute+'/labels.txt','r')
  
  targetLang = []
  for line in labels:
    lineSplit = line.split(' ')[1]
    targetLang.append(lineSplit.split('\n')[0])
  
  lines = len(y)
  
  for r in range(lines): #lines
    corrLang = targetLang[r]
    
    totTests += 1
    results = zeros(N)
    dists = zeros(N)
    w = [y[r]]
    z = [x[r]]
        
    for i in range(N): #N
      p_label, p_acc, p_val = svm_predict(w, z, eval(short[i]+'Model'))
      
      if numpy.sign(p_label) == numpy.sign(p_val):
        results[i] = p_label[0]
        dists[i] = p_val[0][0]
      else:
        results[i] = p_label[0]
        dists[i] = -p_val[0][0]
    
    
    if corrLang == oosLang:
      continue
      for i in range(N):
        AntiModels[i].append(dists)
      
    else:
      index = langMapper[corrLang]
      
      Models[index].append(dists)
    
      for i in range(N):
        if i == index:
          continue
                  
        AntiModels[i].append(dists)

for k in range(N):
  modelFile = open('distances/'+S+'/'+attribute+'/NIST/'+short[k]+'Model.txt','w')
  antiFile = open('distances/'+S+'/'+attribute+'/NIST/'+short[k]+'Anti.txt','w')
  
  M = len(Models[k])
  for i in range(M):
    L = len(Models[k][i])
    for j in range(L):
      modelFile.write(str(Models[k][i][j]))
      if j == L-1:
        continue
      modelFile.write(' ')
    if i == M-1:
      break
    modelFile.write('\n')
    
  modelFile.close()
  
  M = len(AntiModels[k])
  for i in range(M):
    L = len(AntiModels[k][i])
    for j in range(L):
      antiFile.write(str(AntiModels[k][i][j]))
      if j == L-1:
        continue
      antiFile.write(' ')
    if i == M-1:
      break
    antiFile.write('\n')
      
  modelFile.close()
  antiFile.close()
   
    
