#make SVM distances which is used for testing

import os, numpy, math
from numpy import zeros,sign
from svmutil import *

languages = ['arabic', 'english', 'farsi', 'french', 'german', 'hindi', 'japanese', 'korean', 'mandarin', 'spanish', 'tamil', 'vietnamese']
short = ['ar', 'en', 'fa', 'fr', 'ge', 'hi', 'ja', 'ko', 'ma', 'sp', 'ta', 'vi']
N = len(languages)
totTests = 0
tests = zeros(N)

S = '200'
#Choose on of the attributes
#attribute = 'manner'
#attribute = 'place'
attribute = 'combine'

for i in range(N):
  vars()[short[i]+'Model'] = svm_load_model('models/'+S+'/'+attribute+'/'+short[i]+'.model')


#testDir = 'devtest'
#testMod = 'Devtest'

testDir = 'evltest'
testMod = 'Evltest'

Models = []
AntiModels = []
for k in range(N):
  model = []
  anti = []
  Models.insert(k,model)
  AntiModels.insert(k,anti)

for k in range(N): #N
  
  y ,x = svm_read_problem(testDir+'Documents/'+S+'/'+attribute+'/'+short[k]+testMod)
  lines = len(y)
  for r in range(lines): #lines
    totTests += 1
    tests[k] += 1
    results = zeros(N)
    dists = zeros(N)
    w = [y[r]]
    z = [x[r]]
        
    for i in range(N): #N
      p_label, p_acc, p_val = svm_predict(w, z, eval(short[i]+'Model'))
      print str(p_label[0])+' '+str(p_val[0][0])
      
      if numpy.sign(p_label) == numpy.sign(p_val):
        results[i] = p_label[0]
        dists[i] = p_val[0][0]
      else:
        results[i] = p_label[0]
        dists[i] = -p_val[0][0]
          
    for i in range(N):
      if i == k:
        Models[i].append(dists)
      
      else:
        AntiModels[i].append(dists)
    
for k in range(N):
  modelFile = open('distances/'+S+'/'+attribute+'/'+testDir+'/'+short[k]+'Model.txt','w')
  antiFile = open('distances/'+S+'/'+attribute+'/'+testDir+'/'+short[k]+'Anti.txt','w')
  
  M = len(Models[k])
  for i in range(M):
    L = len(Models[k][i])
    for j in range(L):
      modelFile.write(str(Models[k][i][j]))
      if j == L-1:
        continue
      modelFile.write(' ')
    if i == M-1:
      break
    modelFile.write('\n')
    
  modelFile.close()
  
  M = len(AntiModels[k])
  for i in range(M):
    L = len(AntiModels[k][i])
    for j in range(L):
      antiFile.write(str(AntiModels[k][i][j]))
      if j == L-1:
        continue
      antiFile.write(' ')
    if i == M-1:
      break
    antiFile.write('\n')
      
  modelFile.close()
  antiFile.close()
    
    
